Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.cpp	(revision 99437)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.cpp	(revision 99438)
@@ -331,8 +331,8 @@
 #ifdef VBOX_WS_X11
     /* Check whether we have compositing manager running: */
-    m_fCompositingManagerRunning = NativeWindowSubsystem::isCompositingManagerRunning(X11XServerAvailable());
+    m_fCompositingManagerRunning = NativeWindowSubsystem::isCompositingManagerRunning(X11ServerAvailable());
 
     /* Acquire current Window Manager type: */
-    m_enmWindowManagerType = NativeWindowSubsystem::windowManagerType(X11XServerAvailable());
+    m_enmWindowManagerType = NativeWindowSubsystem::windowManagerType(X11ServerAvailable());
 #endif /* VBOX_WS_X11 */
 
@@ -3024,5 +3024,5 @@
 
 #ifdef VBOX_WS_X11
-bool UICommon::X11XServerAvailable() const
+bool UICommon::X11ServerAvailable() const
 {
     return m_enmDisplayServerType == DisplayServerType_XWayland
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.h	(revision 99437)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.h	(revision 99438)
@@ -216,5 +216,5 @@
         bool isCompositingManagerRunning() const { return m_fCompositingManagerRunning; }
         /** Returns true if the detected display server type is either xorg or xwayland. */
-        bool X11XServerAvailable() const;
+        bool X11ServerAvailable() const;
 #endif
     /** @} */
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UICursor.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UICursor.cpp	(revision 99437)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UICursor.cpp	(revision 99438)
@@ -49,5 +49,5 @@
         (UICommon::qtRTMajorVersion() == 5 && UICommon::qtRTMinorVersion() < 11))
     {
-        if (NativeWindowSubsystem::checkExtension(uiCommon().X11XServerAvailable(), "RENDER"))
+        if (NativeWindowSubsystem::checkExtension(uiCommon().X11ServerAvailable(), "RENDER"))
             pWidget->setCursor(cursor);
     }
@@ -75,5 +75,5 @@
         (UICommon::qtRTMajorVersion() == 5 && UICommon::qtRTMinorVersion() < 11))
     {
-        if (NativeWindowSubsystem::checkExtension(uiCommon().X11XServerAvailable(), "RENDER"))
+        if (NativeWindowSubsystem::checkExtension(uiCommon().X11ServerAvailable(), "RENDER"))
             pWidget->setCursor(cursor);
     }
@@ -101,5 +101,5 @@
         (UICommon::qtRTMajorVersion() == 5 && UICommon::qtRTMinorVersion() < 11))
     {
-        if (NativeWindowSubsystem::checkExtension(uiCommon().X11XServerAvailable(), "RENDER"))
+        if (NativeWindowSubsystem::checkExtension(uiCommon().X11ServerAvailable(), "RENDER"))
             pWidget->unsetCursor();
     }
@@ -127,5 +127,5 @@
         (UICommon::qtRTMajorVersion() == 5 && UICommon::qtRTMinorVersion() < 11))
     {
-        if (NativeWindowSubsystem::checkExtension(uiCommon().X11XServerAvailable(), "RENDER"))
+        if (NativeWindowSubsystem::checkExtension(uiCommon().X11ServerAvailable(), "RENDER"))
             pWidget->unsetCursor();
     }
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDesktopWidgetWatchdog.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDesktopWidgetWatchdog.cpp	(revision 99437)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDesktopWidgetWatchdog.cpp	(revision 99438)
@@ -790,5 +790,5 @@
 #ifdef VBOX_WS_X11
 # define QWINDOWSIZE_MAX ((1<<24)-1)
-    if (pWidget->isWindow() && pWidget->isVisible() && uiCommon().X11XServerAvailable())
+    if (pWidget->isWindow() && pWidget->isVisible() && uiCommon().X11ServerAvailable())
     {
         // WORKAROUND:
@@ -862,5 +862,5 @@
 #elif defined(VBOX_WS_X11)
 
-    fResult &= NativeWindowSubsystem::activateWindow(uiCommon().X11XServerAvailable(), wId, fSwitchDesktop);
+    fResult &= NativeWindowSubsystem::activateWindow(uiCommon().X11ServerAvailable(), wId, fSwitchDesktop);
 
 #else
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 99437)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 99438)
@@ -2146,5 +2146,5 @@
 {
 #ifdef VBOX_WS_X11
-    NativeWindowSubsystem::setWMClass(uiCommon().X11XServerAvailable(), this, "VirtualBox Manager", "VirtualBox Manager");
+    NativeWindowSubsystem::setWMClass(uiCommon().X11ServerAvailable(), this, "VirtualBox Manager", "VirtualBox Manager");
 #endif
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIFrameBuffer.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIFrameBuffer.cpp	(revision 99437)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIFrameBuffer.cpp	(revision 99438)
@@ -1146,5 +1146,5 @@
 
 #ifdef VBOX_WS_X11
-    if (uiCommon().X11XServerAvailable())
+    if (uiCommon().X11ServerAvailable())
         /* Resync Qt and X11 Server (see xTracker #7547). */
         XSync(NativeWindowSubsystem::X11GetDisplay(), false);
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIKeyboardHandler.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIKeyboardHandler.cpp	(revision 99437)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIKeyboardHandler.cpp	(revision 99438)
@@ -266,5 +266,5 @@
 
 #elif defined(VBOX_WS_X11)
-        if (uiCommon().X11XServerAvailable())
+        if (uiCommon().X11ServerAvailable())
         {
             /* On X11, we are using XCB stuff to grab the keyboard.
@@ -371,5 +371,5 @@
 
 #elif defined(VBOX_WS_X11)
-        if (uiCommon().X11XServerAvailable())
+        if (uiCommon().X11ServerAvailable())
         {
             /* On X11, we are using XCB stuff to grab the keyboard.
@@ -1037,5 +1037,5 @@
     /* Global settings: */
 #ifdef VBOX_WS_X11
-    if (uiCommon().X11XServerAvailable())
+    if (uiCommon().X11ServerAvailable())
     {
         /* Initialize the X keyboard subsystem: */
@@ -1788,5 +1788,5 @@
 
 #elif defined(VBOX_WS_X11)
-    if (uiCommon().X11XServerAvailable())
+    if (uiCommon().X11ServerAvailable())
     {
         Q_UNUSED(pHotKey);
@@ -1865,5 +1865,5 @@
 
 #elif defined(VBOX_WS_X11)
-    if (uiCommon().X11XServerAvailable())
+    if (uiCommon().X11ServerAvailable())
     {
         Window   wDummy1, wDummy2;
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp	(revision 99437)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp	(revision 99438)
@@ -150,7 +150,7 @@
         strWindowName = QString("VirtualBox Machine UUID: %1").arg(uiCommon().managedVMUuid().toString());
     /* Assign WM_CLASS property: */
-    NativeWindowSubsystem::setWMClass(uiCommon().X11XServerAvailable(), this, strWindowName, strWindowClass);
+    NativeWindowSubsystem::setWMClass(uiCommon().X11ServerAvailable(), this, strWindowName, strWindowClass);
     /* Tell the WM we are well behaved wrt Xwayland keyboard-grabs: */
-    NativeWindowSubsystem::setXwaylandMayGrabKeyboardFlag(uiCommon().X11XServerAvailable(), this);
+    NativeWindowSubsystem::setXwaylandMayGrabKeyboardFlag(uiCommon().X11ServerAvailable(), this);
 #endif
 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIHostComboEditor.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIHostComboEditor.cpp	(revision 99437)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIHostComboEditor.cpp	(revision 99438)
@@ -573,5 +573,5 @@
 #elif defined(VBOX_WS_X11)
     /* Initialize the X keyboard subsystem: */
-    if (uiCommon().X11XServerAvailable())
+    if (uiCommon().X11ServerAvailable())
         initMappedX11Keyboard(NativeWindowSubsystem::X11GetDisplay(), gEDataManager->remappedScanCodes());
 #endif /* VBOX_WS_X11 */
@@ -747,5 +747,5 @@
 
 # elif defined(VBOX_WS_X11)
-    if (uiCommon().X11XServerAvailable())
+    if (uiCommon().X11ServerAvailable())
     {
         /* Make sure it's generic XCB event: */