Index: trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 99478)
+++ trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 99479)
@@ -1278,7 +1278,7 @@
 	src/platform/darwin/UIDesktopServices_darwin_cocoa.mm
 
-if1of ($(KBUILD_TARGET), freebsd linux netbsd openbsd solaris) # X11
+if1of ($(KBUILD_TARGET), freebsd linux netbsd openbsd solaris) # U*nix
  VirtualBox_SOURCES += \
- 	src/platform/x11/UIDesktopServices_x11.cpp
+ 	src/platform/x11/UIDesktopServices_nix.cpp
 endif
 
@@ -1615,7 +1615,7 @@
 endif
 
-if1of ($(KBUILD_TARGET), freebsd linux netbsd openbsd solaris) # X11
+if1of ($(KBUILD_TARGET), freebsd linux netbsd openbsd solaris) # Un*x
  UICommon_SOURCES += \
- 	src/platform/x11/VBoxUtils-x11.cpp \
+ 	src/platform/x11/VBoxUtils-nix.cpp \
  	src/platform/x11/XKeyboard-new.cpp
 endif
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.h	(revision 99478)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.h	(revision 99479)
@@ -42,5 +42,5 @@
 #include "UIMediumDefs.h"
 #ifdef VBOX_WS_X11
-# include "VBoxUtils-x11.h"
+# include "VBoxUtils-nix.h"
 #endif
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDesktopWidgetWatchdog.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDesktopWidgetWatchdog.cpp	(revision 99478)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDesktopWidgetWatchdog.cpp	(revision 99479)
@@ -50,5 +50,5 @@
 #ifdef VBOX_WS_X11
 # include "UICommon.h"
-# include "VBoxUtils-x11.h"
+# include "VBoxUtils-nix.h"
 # ifndef VBOX_GUI_WITH_CUSTOMIZATIONS1
 #  include "UIConverter.h"
Index: trunk/src/VBox/Frontends/VirtualBox/src/main.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/main.cpp	(revision 99478)
+++ trunk/src/VBox/Frontends/VirtualBox/src/main.cpp	(revision 99479)
@@ -75,5 +75,5 @@
 # include <unistd.h>
 # include <X11/Xlib.h>
-# include "VBoxUtils-x11.h"
+# include "VBoxUtils-nix.h"
 # if defined(RT_OS_LINUX) && defined(DEBUG)
 #  include <signal.h>
Index: trunk/src/VBox/Frontends/VirtualBox/src/platform/x11/UIDesktopServices_nix.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/platform/x11/UIDesktopServices_nix.cpp	(revision 99479)
+++ trunk/src/VBox/Frontends/VirtualBox/src/platform/x11/UIDesktopServices_nix.cpp	(revision 99479)
@@ -0,0 +1,86 @@
+/* $Id$ */
+/** @file
+ * VBox Qt GUI - Qt GUI - Utility Classes and Functions specific to X11..
+ */
+
+/*
+ * Copyright (C) 2010-2023 Oracle and/or its affiliates.
+ *
+ * This file is part of VirtualBox base platform packages, as
+ * available from https://www.virtualbox.org.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation, in version 3 of the
+ * License.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <https://www.gnu.org/licenses>.
+ *
+ * SPDX-License-Identifier: GPL-3.0-only
+ */
+
+/* VBox includes */
+#include "UIDesktopServices.h"
+
+/* Qt includes */
+#include <QCoreApplication>
+#include <QDesktopServices>
+#include <QDir>
+#include <QFile>
+#include <QTextStream>
+#include <QUrl>
+
+
+bool UIDesktopServices::createMachineShortcut(const QString & /* strSrcFile */, const QString &strDstPath, const QString &strName, const QUuid &uUuid)
+{
+    QFile link(strDstPath + QDir::separator() + strName + ".desktop");
+    if (link.open(QFile::WriteOnly | QFile::Truncate))
+    {
+        const QString strVBox = QDir::toNativeSeparators(QCoreApplication::applicationDirPath() + "/" + VBOX_GUI_VMRUNNER_IMAGE);
+        QTextStream out(&link);
+#ifndef VBOX_IS_QT6_OR_LATER /* QTextStream defaults to UTF-8 only since qt6 */
+        out.setCodec("UTF-8");
+#endif
+#if QT_VERSION >= QT_VERSION_CHECK(5, 14, 0)
+# define QT_ENDL Qt::endl
+#else
+# define QT_ENDL endl
+#endif
+        /* Create a link which starts VirtualBox with the machine uuid. */
+        out << "[Desktop Entry]" << QT_ENDL
+            << "Encoding=UTF-8" << QT_ENDL
+            << "Version=1.0" << QT_ENDL
+            << "Name=" << strName << QT_ENDL
+            << "Comment=Starts the VirtualBox machine " << strName << QT_ENDL
+            << "Type=Application" << QT_ENDL
+            << "Exec=" << strVBox << " --comment \"" << strName << "\" --startvm \"" << uUuid.toString() << "\"" << QT_ENDL
+            << "Icon=virtualbox-vbox.png" << QT_ENDL;
+        /* This would be a real file link entry, but then we could also simply
+         * use a soft link (on most UNIX fs):
+        out << "[Desktop Entry]" << QT_ENDL
+            << "Encoding=UTF-8" << QT_ENDL
+            << "Version=1.0" << QT_ENDL
+            << "Name=" << strName << QT_ENDL
+            << "Type=Link" << QT_ENDL
+            << "Icon=virtualbox-vbox.png" << QT_ENDL
+        */
+        link.setPermissions(link.permissions() | QFile::ExeOwner);
+        /** @todo r=bird: check status here perhaps, might've run out of disk space or
+         *        some such thing... */
+        return true;
+    }
+    return false;
+}
+
+bool UIDesktopServices::openInFileManager(const QString &strFile)
+{
+    QFileInfo fi(strFile);
+    return QDesktopServices::openUrl(QUrl("file://" + QDir::toNativeSeparators(fi.absolutePath()), QUrl::TolerantMode));
+}
+
Index: trunk/src/VBox/Frontends/VirtualBox/src/platform/x11/UIDesktopServices_x11.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/platform/x11/UIDesktopServices_x11.cpp	(revision 99478)
+++ 	(revision )
@@ -1,86 +1,0 @@
-/* $Id$ */
-/** @file
- * VBox Qt GUI - Qt GUI - Utility Classes and Functions specific to X11..
- */
-
-/*
- * Copyright (C) 2010-2023 Oracle and/or its affiliates.
- *
- * This file is part of VirtualBox base platform packages, as
- * available from https://www.virtualbox.org.
- *
- * This program is free software; you can redistribute it and/or
- * modify it under the terms of the GNU General Public License
- * as published by the Free Software Foundation, in version 3 of the
- * License.
- *
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, see <https://www.gnu.org/licenses>.
- *
- * SPDX-License-Identifier: GPL-3.0-only
- */
-
-/* VBox includes */
-#include "UIDesktopServices.h"
-
-/* Qt includes */
-#include <QCoreApplication>
-#include <QDesktopServices>
-#include <QDir>
-#include <QFile>
-#include <QTextStream>
-#include <QUrl>
-
-
-bool UIDesktopServices::createMachineShortcut(const QString & /* strSrcFile */, const QString &strDstPath, const QString &strName, const QUuid &uUuid)
-{
-    QFile link(strDstPath + QDir::separator() + strName + ".desktop");
-    if (link.open(QFile::WriteOnly | QFile::Truncate))
-    {
-        const QString strVBox = QDir::toNativeSeparators(QCoreApplication::applicationDirPath() + "/" + VBOX_GUI_VMRUNNER_IMAGE);
-        QTextStream out(&link);
-#ifndef VBOX_IS_QT6_OR_LATER /* QTextStream defaults to UTF-8 only since qt6 */
-        out.setCodec("UTF-8");
-#endif
-#if QT_VERSION >= QT_VERSION_CHECK(5, 14, 0)
-# define QT_ENDL Qt::endl
-#else
-# define QT_ENDL endl
-#endif
-        /* Create a link which starts VirtualBox with the machine uuid. */
-        out << "[Desktop Entry]" << QT_ENDL
-            << "Encoding=UTF-8" << QT_ENDL
-            << "Version=1.0" << QT_ENDL
-            << "Name=" << strName << QT_ENDL
-            << "Comment=Starts the VirtualBox machine " << strName << QT_ENDL
-            << "Type=Application" << QT_ENDL
-            << "Exec=" << strVBox << " --comment \"" << strName << "\" --startvm \"" << uUuid.toString() << "\"" << QT_ENDL
-            << "Icon=virtualbox-vbox.png" << QT_ENDL;
-        /* This would be a real file link entry, but then we could also simply
-         * use a soft link (on most UNIX fs):
-        out << "[Desktop Entry]" << QT_ENDL
-            << "Encoding=UTF-8" << QT_ENDL
-            << "Version=1.0" << QT_ENDL
-            << "Name=" << strName << QT_ENDL
-            << "Type=Link" << QT_ENDL
-            << "Icon=virtualbox-vbox.png" << QT_ENDL
-        */
-        link.setPermissions(link.permissions() | QFile::ExeOwner);
-        /** @todo r=bird: check status here perhaps, might've run out of disk space or
-         *        some such thing... */
-        return true;
-    }
-    return false;
-}
-
-bool UIDesktopServices::openInFileManager(const QString &strFile)
-{
-    QFileInfo fi(strFile);
-    return QDesktopServices::openUrl(QUrl("file://" + QDir::toNativeSeparators(fi.absolutePath()), QUrl::TolerantMode));
-}
-
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIKeyboardHandler.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIKeyboardHandler.cpp	(revision 99478)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIKeyboardHandler.cpp	(revision 99479)
@@ -71,5 +71,5 @@
 #ifdef VBOX_WS_X11
 # include "XKeyboard.h"
-# include "VBoxUtils-x11.h"
+# include "VBoxUtils-nix.h"
 #endif
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 99478)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 99479)
@@ -82,5 +82,5 @@
 #endif
 #ifdef VBOX_WS_X11
-# include "VBoxUtils-x11.h"
+# include "VBoxUtils-nix.h"
 #endif
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMouseHandler.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMouseHandler.cpp	(revision 99478)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMouseHandler.cpp	(revision 99479)
@@ -53,5 +53,5 @@
 #endif
 #ifdef VBOX_WS_X11
-# include "VBoxUtils-x11.h"
+# include "VBoxUtils-nix.h"
 #endif
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIDisplayFeaturesEditor.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIDisplayFeaturesEditor.cpp	(revision 99478)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIDisplayFeaturesEditor.cpp	(revision 99479)
@@ -34,5 +34,5 @@
 #include "UIDisplayFeaturesEditor.h"
 #ifdef VBOX_WS_X11
-# include "VBoxUtils-x11.h"
+# include "VBoxUtils-nix.h"
 #endif
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIHostComboEditor.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIHostComboEditor.cpp	(revision 99478)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIHostComboEditor.cpp	(revision 99479)
@@ -51,5 +51,5 @@
 #elif defined(VBOX_WS_X11)
 # include "XKeyboard.h"
-# include "VBoxUtils-x11.h"
+# include "VBoxUtils-nix.h"
 #endif
 